# dies sind die Hexreprsentationen von X Y Z R (siehe Fahrbefehl konstruieren)
set OWIS_MOTSTR {58 59 5A 52}

# Vorbelegung Schrittweitentabelle:
set OWIS_STEPS {1 1 1 1}

# maximale Anzahl Schritte pro Fahrbefehl
set OWIS_MAX_STEPS 65535

# Devicevariable
set owisdevice -1

# Initialisiere IEEE Interface
# Rckgabe: 0 ein Fehler     1 ok
proc owisgpibinit {} {
	global owisdevice

	set owisdevice [gpib find owismotor]	
	gpib sic $owisdevice 
	gpib ren $owisdevice 1
	gpib clear $owisdevice
	return 1
}

# Setze die Zuordnung Achse <---> Schrittweite
proc owisinit {which steps} {
	global OWIS_STEPS 
	
	set OWIS_STEPS [lreplace $OWIS_STEPS $which $which $steps]
}

# Bewege einen OWIS Motor (Nummer <which>) um die Distanz <dist>
# Damit die richtigen Einheiten gefahren werden, mssen die Motoren richtig
# 	mittels owisinit initialisiert werden
# Weicht der Rueckgabewert von der gewnschten Strecke ab, ist ein Fehler
#	aufgetreten 
proc owismovmot {which dist} {
	global owisdevice
    global OWIS_MOTSTR OWIS_STEPS OWIS_MAX_STEPS

	set absval [expr abs ($dist)]
	set steps [expr {$absval / [lindex $OWIS_STEPS $which]}]
	set steps [expr int ($steps)]

# schaue, ob der Fahrbefehl in einem oder geteilt verschickt werden mu
	while { $steps > $OWIS_MAX_STEPS } {
		if { $dist < 0 } {
			set newdist [expr -$OWIS_MAX_STEPS * [lindex $OWIS_STEPS $which]]
			if { [movmot $which $newdist] != $newdist} {
				return 0
			} 
			set steps [expr $steps - $OWIS_MAX_STEPS]
		} else {
			set newdist [expr -$OWIS_MAX_STEPS * [lindex $OWIS_STEPS $which]]
			if { [movmot $which $newdist] != $newdist} {
				return 0
			}
			set steps [expr $steps - $OWIS_MAX_STEPS]
		}
	}
# konstruiere Fahrbefehl
# leider kann TCL ja keine Nullbytes vernnftig verarbeiten, also mu der
# Fahrbefehl als ein Integer gebastelt werden:
#          1.Byte: Achse      2. & 3. Byte	Distanz        4. Byte Richtung

	set weg  [ lindex $OWIS_MOTSTR $which ]
	append weg [ format "%02X%02X" [ expr $steps % 256 ] [ expr $steps / 256 ] ]

	set weg3 3E
	if { $dist < 0 } {
		set weg3 3C
	}
	append weg $weg3

# schicke Fahrbefehl
	gpib hexwrite $owisdevice $weg
# puts $weg
	return [owismoterr $which $dist]
}


# Lies Motorstatusbyte und pass auf, da kein Fehler auftritt:
proc owismoterr {which dist} {
	global owisdevice OWIS_MOTSTR

	set o_answ1 [expr 128]
	set o_answ2 [expr 128]
	while { [ expr ($o_answ1 & 128) || ($o_answ2 & 128)]  } {
		scan [gpib read $owisdevice 2] "%c%c" o_answ1 o_answ2
		if { $o_answ1 & 0x3f } {
#			append weg  [ lindex $OWIS_MOTSTR $which ] 00 00 >
#			gpib hexwrite $owisdevice $weg
			return 0
		}
	}
	return $dist
}

        